<template>
  <section class="section">
    <div class="grid-half my-4">
      <label :class="{ 'config-type': true, selected: configType === 'inter' }">
        <input
          v-model="configType"
          type="radio"
          class="appearance-none"
          value="inter"
        >
        Inter
      </label>

      <label :class="{ 'config-type': true, selected: configType === 'intra' }">
        <input
          v-model="configType"
          type="radio"
          class="appearance-none"
          value="intra"
        >
        Intra
      </label>
    </div>

    <template v-if="configType">
      <ConfigIntra
        v-if="configType === 'intra'"
        v-model="config"
      />

      <ConfigInter
        v-else-if="configType === 'inter'"
        v-model="config"
      />

      <hr class="border-b my-8">

      <h2 class="text-center my-8">
        Mine exceptional behavioral patterns
      </h2>

      <div class="flex-center flex-col my-4">
        <button
          class="big-btn text-2xl"
          @click="run"
        >
          Launch
        </button>
      </div>
    </template>
  </section>
</template>

<style lang="postcss" scoped>
.config-type {
  @apply flex items-center justify-center cursor-pointer p-4 bg-grey-light;

  &.selected, &:hover {
    @apply bg-teal-light;
  }

  &:hover {
    @apply opacity-75;
  }

  transition: all .1s ease-in-out;
}
</style>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import ConfigInter from '@/views/ConfigInter.vue'
import ConfigIntra from '@/views/ConfigIntra.vue'

@Component({
  components: {
    ConfigInter,
    ConfigIntra
  }
})
export default class Config extends Vue {
  @State settings: any
  @State userID: string

  config = {}

  get configType () {
    return this.settings.configType
  }

  set configType (configType: string) {
    this.$store.commit('SET_SETTINGS', { configType })
  }

  run () {
    this.$store.commit('setJobID', null)

    this.$store.commit('setStatus', {
      loading: true,
      message: 'Running...'
    })

    const protocol = window.location.protocol === 'https:' ? 'wss' : 'ws'
    const socket = new WebSocket(`${protocol}://${window.location.host}/ws`)

    socket.onopen = () => {
      socket.send(JSON.stringify({
        data: JSON.stringify(this.config, null, 2),
        userID: this.userID
      }))
    }

    const onProgress = (msg) => {
      this.$store.commit('setStatus', {
        loading: true,
        message: msg
      })
    }

    const onDone = ({ userID, jobID }) => {
      this.$store.commit('setUserID', userID)
      this.$store.commit('setJobID', jobID)
      this.$router.push('/results')
      this.$store.commit('setStatus', {
        message: 'Execution complete!'
      })
    }

    const onFailed = (msg) => {
      this.$store.commit('setStatus', {
        message: 'Execution failed.'
      })
    }

    socket.onmessage = e => {
      const data = JSON.parse(e.data)

      switch (data.type) {
        case 'progress': {
          onProgress(data.data)
          break
        }
        case 'done': {
          onDone(data.data)
          break
        }
        case 'failed': {
          onFailed(data.data)
          break
        }
      }
    }
  }
}
</script>
